/* Copyright (c) 2000-2001 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;
var prefExecutable = null;
// preferences used in the pref window
var _elementIDs = [
//XXX need infrastructure for these in the editor
//    "pythonUseLinting",
//    "pythonUseTooltips"
    "pythonDefaultInterpreter",
];


//---- functions

function PrefPython_OkCallback(prefset)
{
    var ok = true;
    
    // ensure that the default python interpreter is valid
    var defaultInterp = prefset.getStringPref("pythonDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            alert("No Python interpreter could be found at '" +
                  defaultInterp + "'. You must make another selection " +
                  "for the default Python interpreter.\n");
            ok = false;
            document.getElementById("pythonDefaultInterpreter").focus();
        }
    }

    return ok;
}

// Populate the (tree) list of available Python interpreters on the current
// system.
function PrefPython_PopulatePythonInterps()
{
    var availInterpList = document.getElementById("pythonDefaultInterpreter");

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    availInterpList.removeAllItems();
    availInterpList.appendItem("Finding available Python interpreters...");
    
    // get a list of installed Python interpreters
    var sysUtils = Components.classes['@activestate.com/koSysUtils;1'].
        getService(Components.interfaces.koISysUtils);
    var availInterps = new Array();
    availInterps = sysUtils.WhichAll("python", new Object());

    availInterpList.removeAllItems();
    availInterpList.appendItem("Find on Path",'');

    var found = false;
    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("no-avail-interps-message").removeAttribute("collapsed");
    } else {
        for (var i = 0; i < availInterps.length; i++) {
            availInterpList.appendItem(availInterps[i],availInterps[i]);
            if (availInterps[i] == prefExecutable) found = true;
        }
    }
    if (!found && prefExecutable)
        availInterpList.appendItem(prefExecutable,prefExecutable);
    _findingInterps = false;
}


function PrefPython_OnLoad()
{
    var tag = 'chrome://jaguar/content/pref/pref-python.xul';
    if (parent.hPrefWindow.prefset.hasStringPref('pythonDefaultInterpreter') &&
        parent.hPrefWindow.prefset.getStringPref('pythonDefaultInterpreter'))
        prefExecutable = parent.hPrefWindow.prefset.getStringPref('pythonDefaultInterpreter');
    else
        prefExecutable = '';
    PrefPython_PopulatePythonInterps();

    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefPython_OkCallback, tag); 
}

function loadPythonExecutable()
{
    var pythonExe = filepicker_openExeFile();
    if (pythonExe != null) {
        var availInterpList = document.getElementById("pythonDefaultInterpreter");
        availInterpList.selectedItem = availInterpList.appendItem(pythonExe, pythonExe);
    }
}


