/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * Komodo's Tip of the Day dialog
 *
 */


//---- globals

var _gParentWindow = opener;    // a hook back to the parent window
var _gNumTips = 33;
var _gPrefSvc = null;

var _gContentWidget = null; // the DOM node for the tip content
var _gPrefix = null;        // prefix for tip URLs


//---- interface routines for tipoftheday.xul

function Tip_OnLoad(prefix /*=""*/, contentWidget /*="tip-content" node*/)
{
    try {
        trace_onload();

        if (typeof(contentWidget) == "undefined" || !contentWidget)
            contentWidget = document.getElementById("tip-content");
        if (typeof(prefix) == "undefined" || !prefix) prefix = "";
        _gContentWidget = contentWidget;
        _gPrefix = prefix;
        
        _gPrefSvc = Components.classes["@activestate.com/koPrefService;1"].
                    getService(Components.interfaces.koIPrefService);
        if (document.getElementById("dialog")) {
            var dialog = document.getElementById("dialog");
            var nextButton = dialog.getButton('extra1');
            nextButton.setAttribute('label', 'Next Tip');
            nextButton.setAttribute('accesskey', 'n');
            var closeButton = dialog.getButton('cancel');
            closeButton.setAttribute('label', 'Close');
            closeButton.setAttribute('accesskey', 'c');
            var showAtStartup = _gPrefSvc.prefs.getBooleanPref("tipShowAtStartup");
            document.getElementById("show-tip-checkbox").checked = showAtStartup;
            closeButton.focus();
            //SetWindowLocation();
        }
        Tip_NextTip();
    } catch (e) {
        log.exception(e);
    }
}

function Tip_OnUnload()
{
    var showAtStartup = document.getElementById("show-tip-checkbox").checked;
    _gPrefSvc.prefs.setBooleanPref("tipShowAtStartup", showAtStartup);
}


function Tip_NextTip()
{
    try {
        // Get the current tip number and display that tip.
        var tipNumber = _gPrefSvc.prefs.getLongPref("tipNumber");
        var tipUrl = "chrome://jaguar/content/tipoftheday/" + _gPrefix + "tip" + tipNumber +
                     ".html";
        //dump("Tip_NextTip(): setting tip to " + tipUrl + "\n");

        _gContentWidget.setAttribute("src", tipUrl);
        
        // Increment the tip number.
        tipNumber = (Number(tipNumber) + 1) % _gNumTips;
        _gPrefSvc.prefs.setLongPref("tipNumber", tipNumber);
    } catch (e) {
        log.exception(e);
    }
}


// Routine for some tip content HTML to call.
function Tip_OpenPrefsPanel(name)
{
    if (document.getElementById("dialog")) {
        opener.prefs_doGlobalPrefs(name);
    } else {
        prefs_doGlobalPrefs(name);
    }
}
