/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* Functions for working with Komodo's Web Services Setup Wizard functionality.
 */


//---- internal support routines

function _AssertKnownLanguage(language)
{
    // Assert that the language is one of the known ones for WebService setup
    // work. This is more for my current sanity than good s/w engineering.
    if (language != "Python" && language != "Perl" && language != "PHP") {
        throw "Don't know how to setup language '"+language+"' for Web Services";
    }
}


function _Setup(language, implicit)
{
    var obj = new Object();
    obj.implicit = implicit;
    obj.language = language;
    window.openDialog(
        "chrome://jaguar/content/webservices/setup/wsSetupWizard.xul",
        "komodo_ws_setup_wizard",
        "chrome,dialog=yes,close=yes,dependent=yes,modal=yes",
        obj);
    // for some reason focus doesn't return normally, so hack it!
    // (scintilla appears focused, but no keystrokes get there.)
    window.focus();
}



//---- public interface

function WSSetup_SetupIfHaveNotAlready(language)
{
    // Called before WS code insertion is done in user's code.  This is an
    // implicit call, as far as the user is concerned. If the user has been
    // through this process before then the Setup is aborted.
    _AssertKnownLanguage(language);

    var globalPrefSvc = Components.classes["@activestate.com/koPrefService;1"].
                        getService(Components.interfaces.koIPrefService);
    var prefName = "ranWebServicesSetupWizard_For"+language;
    if (!globalPrefSvc.prefs.getBooleanPref(prefName)) {
        _Setup(language, true);
    }
}


function WSSetup_Setup(language)
{
    _AssertKnownLanguage(language);
    _Setup(language, false);
}

function WSSetup_SupportedLanguage(language)
{
    // XX icky, but easier to deal with for now
    try {
        _AssertKnownLanguage(language);
    } catch (e) {
        return false;
    }
    return true;
}
