from xpcom import components, ServerException

from koLanguageServiceBase import *

class koLispLanguage(KoLanguageBase):
    name = "Lisp"
    _reg_desc_ = "%s Language" % name
    _reg_contractid_ = "@activestate.com/koLanguage?language=%s;1" \
                       % (name)
    _reg_clsid_ = "{7B60D626-E3E9-4634-9531-854DF66B1193}"

    defaultExtension = ".lis"
    commentDelimiterInfo = {
        "line": [ ";" ],
    }
    _comment_styles = [sci_constants.SCE_LISP_COMMENT]
    supportsSmartIndent = "brace"
    
    def get_lexer(self):
        if self._lexer is None:
            self._lexer = KoLexerLanguageService()
            self._lexer.setLexer(components.interfaces.ISciMoz.SCLEX_LISP)
            self._lexer.setKeywords(0, self._keywords)
            self._lexer.supportsFolding = 1
        return self._lexer

    _keywords = [] 

    def get_commenter(self):
        if self._commenter is None:
            self._commenter = KoCommenterLanguageService(
                self.commentDelimiterInfo)
        return self._commenter

