# Copyright (c) 2000-2001 ActiveState Corporation.
# See the file LICENSE.txt for licensing information.

# The Python debug engine

import koRequesterDebugger
from xpcom import components, _xpcom, ServerException, COMException, nsError
import sys
import kdb
import string
import korpc
import os
import copy

from xmlrpclib import Boolean

class PythonRequesterProxy(koRequesterDebugger.RequesterProxy):
    # Use integers instead of xmlrpclib.Boolean because korpc doesn't know how to marshal those
    def _doCall(self, function, args ):
        args = copy.copy( args )
        for arg, value in args.items( ):
            if isinstance( value, Boolean ):
                args[arg] = int( value )

        return koRequesterDebugger.RequesterProxy._doCall( self, function, args )               
    
    def _createRequester( self, url ):            
        return korpc.Server( url )
                         
class koPythonDebugEngine(koRequesterDebugger.koRequesterDebugEngine):
    _reg_clsid_ = "{bd964846-eae0-44f4-a1a6-c0dc5959f7fa}"
    _reg_contractid_ = "@activestate.com/debugger_engine_Python;1"
    
    def __init__(self):
        koRequesterDebugger.koRequesterDebugEngine.__init__(self, "Python")

    def _createRequesterProxy( self, cookie, url ):
        return PythonRequesterProxy( self.language, self.uriConstructor, cookie, url )
