# Copyright (c) 2000-2001 ActiveState Corporation.
# See the file LICENSE.txt for licensing information.

from xpcom import components

class koScriptableInputStream:
    _com_interfaces_ = components.interfaces.nsIScriptableInputStream
    _reg_clsid_ = "{bdc57c38-d644-4658-8aa3-b9f58496b4f4}"
    _reg_contractid_ = "@activestate.com/scriptableInputStream;1"

    def close( self ):
        self.stream.close()

    def init( self, realinput ):
        # realinput is a real nsIInputStream or a koInputStreamHack
        iface = components.interfaces.koIInputStreamHack 
        hack = realinput.QueryInterface( iface )
                              
        self.stream=realinput
        if hack:
            self.read=hack.readStr
        else:
            self.read=self._read

    def read(self, size):
        pass # placeholder -- replaced in init

    def _read(self, size):
        return self.stream.read(size)

    def available(self):
        return self.stream.available()

